#!/usr/bin/env perl

my @new = ();

open (my $maint, '<', "MAINTAINERS")
    or die "$P: Can't read MAINTAINERS file: $!\n";
while (<$maint>) {
    my $line = $_;
    chomp $line;

    if ($line =~ m/^([FX]):\s*(.*)/) {
	my $type = $1;
	my $value = $2;

	$value =~ s@\.@\\\.@g;       ##Convert . to \.
	$value =~ s/\*/\.\*/g;       ##Convert * to .*
	$value =~ s/\?/\./g;         ##Convert ? to .
	##if pattern is a directory and it lacks a trailing slash, add one
	if ((-d $value)) {
	    $value =~ s@([^/])$@$1/@;
	    $line = "$type:\t$value";
	}
    }
    push(@new, $line);
}
close($maint);

open (my $maint, '>', "MAINTAINERS")
    or die "$P: Can't write MAINTAINERS file: $!\n";

foreach my $line (@new) {
    print $maint "$line\n";
}
close($maint);
